/*
 *  Copyright (c) 2008 Cyrille Berger <cberger@cberger.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "GTLTest/Test.h"

#include <GTLCore/CompilationMessages.h>
#include "OpenShiva/Debug.h"

using namespace GTLCore;

#include "TestLexer.h"
#include "TestMetadataLexer.h"
#include "TestMetadataParser.h"
#include "TestSource.h"
#include "TestWrapper.h"
#include "TestKernelThreading.h"
#include "TestKernelProgressReport.h"
#include "TestKernelChannel.h"

GTLTEST_MAIN_BEGIN(TestOpenShiva)
GTLTEST_MAIN_ADD_CASE(TestLexer)
GTLTEST_MAIN_ADD_CASE(TestMetadataLexer )
GTLTEST_MAIN_ADD_CASE(TestMetadataParser)
GTLTEST_MAIN_ADD_CASE(TestSource)
GTLTEST_MAIN_ADD_CASE(TestWrapper)
#ifdef GTLTEST_HAVE_THREAD
GTLTEST_MAIN_ADD_CASE(TestKernelThreading)
#endif
GTLTEST_MAIN_ADD_CASE(TestKernelProgressReport)
GTLTEST_MAIN_ADD_CASE(TestKernelChannel)
GTLTEST_MAIN_END()
